//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Cindy ckong@ittc.ukans.edu
//           David schond@ittc.ukans.edu
//
//  $Id: ItemList.java,v 1.1 2000/08/09 23:03:09 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: ItemList.java,v $
//  Revision 1.1  2000/08/09 23:03:09  cvs
//  Dropped the ROM_ prefix on all files; dumped getElt() method from List.java, made Universe a subclass of BaseObject. --David
//
//  Revision 1.1  2000/08/09 04:29:53  cvs
//  The data structures for the files I have added are more or less
//  complete. For several of the classes no implementation has been given
//  yet. Their presence gives an idea of the inheritance hierarchy.
//  -- Cindy
//
//
//
//=============================================================================
package ROM;

/** This represents the <B>ItemList</B> object
 * @author <I> Cindy Kong and David Schonberger </I>
 * (ckong@ittc.ukans.edu, schond@ittc.ukans.edu)
 */
public class ItemList
extends List {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public ItemList() {
		super();
	}

	/** To add an item
	 * @param item The Item to add
	 * @return void
	 */
	public void addItem (Item item) {
		addElement(item);
	}

	/** To remove an item
	 * @param item The BaseObject to remove
	 * @return void
	 */
	public void removeItem (Item item) {
		removeElement(item);
	}

	/** To retrieve the first item in the list
	 * @return Item representing the first item
	 */
	public Item firstItem() {
		return (Item)first();
	}

	/** To retrieve the last item in the list
	 * @return Item representing the last object in the list
	 */
	public Item lastItem() {
		return (Item)last();
	}

	/** To check if list contains a specific item
	 * @param item Item present or not in list
	 * @return boolean, true if item present, false otherwise
	 */
	public boolean containsItem(Item item) {
		return containsElement(item);
	}

}
		

