//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Cindy ckong@ittc.ukans.edu
//           David schond@ittc.ukans.edu
//
//  $Id: LetFunction.java,v 1.2 2001/03/12 23:56:47 cvs Exp $
//
//
//=============================================================================

package ROM;
import java.io.*;

/** This represents the <B>ArrayIntegerType</B> object
 * @author <I>Srinivas Akkipeddi</I>
 * <a href="mailto:akki@ittc.ukans.edu"></a>
 */

public class LetFunction extends Expression{
	
	private ItemList itemList;
	private Expression expr;

	/** The primary Constructor
	 * @param parentIn Item representing the parent of this Facet
	 * @return Not applicable
	 */
	public LetFunction(BaseObject parent){
		super(parent);
	}
	
	/** The function to set the ItemList 
	 * @param itemListIn The ItemList 
	 * @return void
	 */
	public void setItemList(ItemList itemListIn){
		itemList = itemListIn;
	}
	
	/**The function to get the ItemList
	 * @param void
	 * @return ItemList 
	 */
	public ItemList getItemList(){
		return itemList;
	}

	/** The function to set the ItemList 
	 * @param exprIn The Expression 
	 * @return void
	 */
	public void setExpression(Expression exprIn){
		expr = exprIn;
	}

	/**The function to get the ItemList
	 * @param void
	 * @return Expression 
	 */
	public Expression getExpression(){
		return expr;
	}
}
