//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Cindy ckong@ittc.ukans.edu
//           David schond@ittc.ukans.edu
//
//  $Id: SequenceValue.java,v 1.5 2000/11/13 21:49:11 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SequenceValue.java,v $
//  Revision 1.5  2000/11/13 21:49:11  cvs
//  Added the function buildROM to all the classes.
//  --srinivas
//
//  Revision 1.4  2000/09/18 20:41:03  cvs
//  Added correct tabbing to files. Also added CVS log info to new files
//  added by Steve Parker (Averstar).
//  -- Cindy
//
//  Revision 1.3  2000/08/30 20:39:11  cvs
//  Changed Expression class to inherit from Value and amended all other classes affected by this change. -David
//
//  Revision 1.2  2000/08/16 18:56:24  cvs
//  Added comments for documentation.
//  All files now compile.
//  -- Cindy
//
//  Revision 1.1  2000/08/11 16:28:24  cvs
//  Replacing Array.java, Set.java, and Sequence.java with files named
//  xxxValue.java. All three are a bit more fleshed out as well, with
//  accessors. Purpose of replacement: To distinguish these classes
//  from those of same name to appear (soon) as subclasses of
//  Type. -David 
//
//  Revision 1.2  2000/08/10 01:04:13  cvs
//  All object in ROM has a parent, therefore implemented the constructors
//  to take in a BaseObject parent.
//  -- Cindy
//
//  Revision 1.1  2000/08/09 23:03:12  cvs
//  Dropped the ROM_ prefix on all files; dumped getElt() method from
//  List.java, made Universe a subclass of BaseObject. --David 
//
//  Revision 1.1  2000/08/09 15:44:14  cvs
//  Just adding some class skeltons for various subclasses of Expression
//
//
//=============================================================================
package ROM;
import java.io.*;
/** This represents the <B>Sequence</B> object
 * @author <I> Cindy Kong and David Schonberger </I>
 * (ckong@ittc.ukans.edu, schond@ittc.ukans.edu)
 */

public class SequenceValue 
extends Expression {

	Type type;
	ItemList elements;    

	/** The primary constructor
	 * @param parent The BaseObject parent of an object of this class
	 * @param typeIn The type of the elements in sequence
	 * @param elementsIn The list of elements in sequence
	 * @return Not applicable
	 */
	public SequenceValue(Item parent, Type typeIn, ItemList elementsIn) {
		super(parent);
		type = typeIn;
		elements = elementsIn;		
	}

	/** To retrieve element type
	 * @return Type representing the type of elements in the sequence
	 */
        public Type getType(){
	        return type;
	}

	/** To return the sequence
	 * @return ItemList list representing the sequence
	 */
        public ItemList getElements(){
	    return elements;
	}

	/** To get the string representation of the object
	 * @return String representing the string of this object
	 */
	public String toString() {
		// to be completed
		return null;
	}

	/** For cases when value references an item.
	 * Irrelevant here.
	 */
	public LabelledItem labelLookup(Label label2){
		return null;
	}

	public void publishROM(PrintWriter pw){
		if (toString() !=null)
			pw.print(toString());
	}

}

		

