//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Cindy ckong@ittc.ukans.edu
//           David schond@ittc.ukans.edu
//
//  $Id: StringLiteral.java,v 1.4 2000/12/03 23:59:46 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: StringLiteral.java,v $
//  Revision 1.4  2000/12/03 23:59:46  cvs
//  Added the new types of array, set and sequence. The methods getType  and alreadyDeclared are also added to get a type that has been previously declared.
//  --srinivas
//
//  Revision 1.3  2000/08/17 20:48:22  cvs
//  Added some members to the literal classes.
//  Modified the lookup algorithm in Universe to remove an error.
//  -- Cindy
//
//  Revision 1.2  2000/08/10 01:04:13  cvs
//  All object in ROM has a parent, therefore implemented the constructors
//  to take in a BaseObject parent.
//  -- Cindy
//
//  Revision 1.1  2000/08/09 23:03:13  cvs
//  Dropped the ROM_ prefix on all files; dumped getElt() method from
//  List.java, made Universe a subclass of BaseObject. --David 
//
//  Revision 1.1  2000/08/09 15:44:15  cvs
//  Just adding some class skeltons for various subclasses of Expression
//
//
//=============================================================================
package ROM;
import java.io.*;
/** This represents the <B>StringLiteral</B> object
 * @author <I> Cindy Kong and David Schonberger </I>
 * (ckong@ittc.ukans.edu, schond@ittc.ukans.edu)
 */

public class StringLiteral 
extends Literal {

	String stringData;

	/** The primary constructor
	 * @param stringIn The String value
	 * @param parent The BaseObject parent of an object of this class
	 * @return Not applicable
	 */
	public StringLiteral(BaseObject parent, String stringIn) {
		super(parent);
		stringData = stringIn;
	}

	/** To get the String data
	 * @return String
	 */
	public String getData() {
		return stringData;
	}

	/** To get the string representation of the object
	 * @return String representing the string of this object
	 */
	public String toString() {
		// to be completed
		return null;
	}

	public void publishROM(PrintWriter pw){
		pw.print(getData());
		return ;
	}
}

		

