//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Cindy ckong@ittc.ukans.edu
//           David schond@ittc.ukans.edu
//
//  $Id: Value.java,v 1.2 2000/08/22 18:40:18 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: Value.java,v $
//  Revision 1.2  2000/08/22 18:40:18  cvs
//  First Commit by Steve Parker, Averstar.  Basic Structure of classes setup for ROM.
//
//  Revision 1.1  2000/08/09 04:29:55  cvs
//  The data structures for the files I have added are more or less
//  complete. For several of the classes no implementation has been given
//  yet. Their presence gives an idea of the inheritance hierarchy.
//  -- Cindy
//
//
//
//=============================================================================
package ROM;

/** This represents the <B>Value</B> object
 * @author <I> Cindy Kong and David Schonberger </I>
 * (ckong@ittc.ukans.edu, schond@ittc.ukans.edu)
 */
public abstract class Value 
extends BaseObject {

	/** The primary Constructor
	 * @param parentIn Item that represents this Value's parent.
	 * @return Not applicable
	 */
	public Value(Item parentIn) {
	    super(parentIn);
	}
	
	/** To look up a label
	 * @return Item corresponding to label
	 */
    public abstract LabelledItem labelLookup(Label label2);
}
		

