//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_AssociationListing.java,v 1.7 2000/08/09 23:37:54 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_AssociationListing.java,v $
//  Revision 1.7  2000/08/09 23:37:54  cvs
//  added publishPVS routines for these classes - Makarand
//
//  Revision 1.6  2000/06/22 17:22:38  cvs
//  I modified the grammar to remove an error during parsing for record and tuple.
//  -- Cindy
//
//  Revision 1.5  2000/05/19 00:03:58  cvs
//  restoring the files after the file system had crashed
//  --srinivas
//
//  Revision 1.5  2000/05/06 00:14:52  cvs
//   The Meta Functions for the term items have been changed to the
//   class SOM_LabelledExpression .The M__Value and M__String have
//   been implemented for the AssociationListing.The meta functions
//   for the declaration items are also implemented in the
//   SOM_DeclarationStatement 
//  --srinivas
//
//  Revision 1.4  2000/02/10 00:37:10  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.3  2000/02/08 18:42:20  cvs
//  Completed populating the object model and publishing the object model.
//  Added 'publishSOM(PrintWriter)' method to all necessary classes
//  (with the help of Makarand and Srini). Removed some unnecessary
//  classes (due to changes brought to the grammar). Renamed
//  SOM_EqualityOperator to SOM_EqualEqualOperator. Modified
//  SldlParser.jj.h to populate the object model. 
//  -- Cindy.
//
//  Revision 1.2  2000/02/02 20:23:47  cvs
//  Committing the class files I have modified due to changes made to
//  the grammar. 
//  -- Cindy
//
//  Revision 1.1  1999/10/27 20:43:28  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:49:19  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.2  1999/07/22 22:53:16  rkamath
//  Lot of changes especially in terms of adding accessors to the OM
//  This does not compile completely, the toString() of SOM_FormalIdentifier
//  is to be completed. This commit is purely for records
//
//  Revision 1.1  1999/07/01 22:58:50  rkamath
//  Added these files pertaining to the <name> nonterminal. However I need to
//  fix the grammar using VHDL style of association.
//
//
//=============================================================================
package SOM;

import util.List;
import util.Link;
import util.ListEnumeration;

import java.io.PrintWriter;
import java.lang.NullPointerException;
import java.io.Serializable;
import java.lang.String;
import java.io.*;
/** This represents the <B>AssociationListing</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_AssociationListing
extends SOM_BaseClass{

	// Modifications brought by Cindy
	//private SOM_AssociationItemList associationList = new SOM_AssociationItemList();
	private SOM_List exprOrUnderscoreList = new SOM_List();

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_AssociationListing() {
		super();
	}

	/** To add to the exprOrUnderscoreList
	 * @param exprOrUnderscore The SOM_Expression or SOM_Underscore 
	 * (use of SOM_BaseClass) to be added 
	 * @return void
	 */
	public void addToList(SOM_BaseClass exprOrUnderscore) {
		exprOrUnderscoreList.addElement(exprOrUnderscore);
	}

	/** To return an enumeration of all the expressions/underscores in this 
	 * list
	 * @return ListEnumeration
	 */
	public ListEnumeration associations() {
		return exprOrUnderscoreList.elements();
	}
    //added by srinivas on 5th may,2000

    /**The Meta Function that gives values in association listing
     * params void
     * @return listenumeration
     */
    public ListEnumeration M__Value(){
	ListEnumeration exprOrUnderscore = associations();
	Object obj;
	SOM_Expression expr;
	List values = new List();
	while (exprOrUnderscore.hasMoreElements()){
	    obj = exprOrUnderscore.nextElement();
	    if (obj instanceof SOM_Expression){
		expr =((SOM_Expression)obj);
		if (expr != null)
		values.addElement(expr);
	    }
	}
	if (values.isEmpty())
	    return (ListEnumeration)null;
	else
	    return values.elements();
    }


     /**The Meta Function that gives strings of expression in association list
     * params void
     * @return listenumeration
     */
    public ListEnumeration M__String(){
	try{
	ListEnumeration exprOrUnderscore = associations();
	Object obj;
	String str ;
	SOM_Expression expr;
	List strings = new List();
	StringWriter sw = new StringWriter();
	PrintWriter pw = new PrintWriter(sw,true);
	while (exprOrUnderscore.hasMoreElements()){
	    obj = exprOrUnderscore.nextElement();
	    if (obj instanceof SOM_Expression){
		expr= (SOM_Expression)obj;
		    expr.publishSOM(pw);
		    pw.flush();
		    pw.close();
		    str = sw.toString();
		    sw.close();
		strings.addElement(str);
		
	    }
	}
	    if (strings.isEmpty())
		return (ListEnumeration)null;
	    else
		return strings.elements();
	}catch (Exception e) {
	    System.out.println(e);
	    return (ListEnumeration)null;
		}
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		ListEnumeration exprOrUnderscoreEnum = associations();
		Object  obj;
		SOM_Expression expr;
		SOM_Underscore under;
		
		pw.print("(");
		obj = exprOrUnderscoreEnum.nextElement();
		if (obj instanceof SOM_Underscore) {
			under = (SOM_Underscore)obj;
			under.publishSOM(pw);
		} else {
			expr = (SOM_Expression)obj;
			expr.publishSOM(pw);
		}
		while (exprOrUnderscoreEnum.hasMoreElements())
			{
				pw.print(",");
				obj = exprOrUnderscoreEnum.nextElement();
				if (obj instanceof SOM_Underscore) {
					under = (SOM_Underscore)obj;
					under.publishSOM(pw);
				} else {
					expr = (SOM_Expression)obj;
					expr.publishSOM(pw);
				}
			}
		pw.print(")");
	}

		/** The publishPVS routine for this class
		 * @return void
		 */
	public void publishPVS(PrintWriter pw) {
			ListEnumeration exprOrUnderscoreEnum = associations();
			Object  obj;
			SOM_Expression expr;
			SOM_Underscore under;
			
			pw.print("(");
			obj = exprOrUnderscoreEnum.nextElement();
			if (obj instanceof SOM_Underscore) {
					under = (SOM_Underscore)obj;
					under.publishSOM(pw);
			} else {
					expr = (SOM_Expression)obj;
					expr.publishPVS(pw);
			}
			while (exprOrUnderscoreEnum.hasMoreElements())
			{
				pw.print(",");
				obj = exprOrUnderscoreEnum.nextElement();
				if (obj instanceof SOM_Underscore) {
					under = (SOM_Underscore)obj;
					under.publishSOM(pw);
				} else {
					expr = (SOM_Expression)obj;
					expr.publishPVS(pw);
				}
			}
		pw.print(")");
	}
}
