//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_ComponentDeclaration.java,v 1.22 2001/03/21 00:05:05 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_ComponentDeclaration.java,v $
//  Revision 1.22  2001/03/21 00:05:05  cvs
//  Added the "design" mode for parameters (SOM_Design.java). Changed the
//  semantics for export clauses. Removed the expression member from
//  SOM_FacetDeclaration.java and SOM_PackageDeclaration.java. Added code
//  to catch error when type-checking fails. Removed the redundant methods
//  getExportList() from SOM_FacetDeclaration.java,
//  SOM_PackageDeclaration.java and SOM_ComponentDeclaration.java.
//  -- Cindy
//
//  Revision 1.21  2001/03/12 23:54:37  cvs
//  Changed the order of precedence of the "=" operator. It now has lowest
//  precedence of all operators except for the "==" operator. Added some
//  type checking for facet expressions and as a result, domain names have
//  to be legal facet names. Removed several bugs as well.
//  -- Cindy
//
//  Revision 1.20  2000/12/04 20:09:50  cvs
//  The assumption, definition and verification blocks are labelled items.
//  -- Cindy
//
//  Revision 1.19  2000/11/13 23:36:39  cvs
//  Changed the way the Items are created.Now they are created through
//  the factory class 
//  --srinivas
//
//  Revision 1.18  2000/11/06 18:12:00  cvs
//  Implementing the loader.
//  -- Cindy
//
//  Revision 1.17  2000/11/06 16:58:00  cvs
//  Added the Meta functions to the component item and some accessor
//  methods to Verification block and the definition block classes 
//  --srinivas
//
//  Revision 1.16  2000/10/22 18:42:02  cvs
//  Meta functions are added to the SOM_InterfaceItem class and the
//  meta function M__Domain is changed so that it returns a string and
//  not SOM_FacetExpression 
//  --srinivas
//
//  Revision 1.15  2000/10/04 03:05:25  cvs
//  Changed some of the meta functions and the facetDeclaration and
//  componentDeclration no longer implement the design unit.This is
//  because all the files should be a package now 
//  --srinivas
//
//  Revision 1.14  2000/07/14 23:01:21  cvs
//  Made changes to the meta functions and added some meta functions
//  to the identifier object. 
//  --srinivas
//
//  Revision 1.13  2000/06/22 17:22:39  cvs
//  I modified the grammar to remove an error during parsing for
//  record and tuple. 
//  -- Cindy
//
//  Revision 1.12  2000/05/18 18:03:41  cvs
//  Due to /projects directory failing and the latest version
//  available is old, I am committing the files again.
//  -- Cindy
//
//  Revision 1.12  2000/05/05 19:28:29  cvs
//  Added:
//  	- use of record and tuple keywords for record and tuple formers
//  	- new syntax for sel, forall, exists, min, max and ran functions
//  	- all expressions between "begin" and "end" are labelled.
//  Also, SOM_FacetBodyItem is no longer an interface, but a class.
//  - Cindy
//
//  Revision 1.11  2000/04/21 02:09:39  cvs
//  Made changes to the publishSOM routine so that the ObjectModel
//  file is correct 
//  --srinivas
//
//  Revision 1.10  2000/04/09 01:50:03  cvs
//   The identifier had a space printed in the publishSOM which was
//   not required for the tick and the at operators so changing the
//   classes and the grammar had the tick and single quote
//   interchanged so modifing the grammar also 
//  --srinivas
//
//  Revision 1.9  2000/04/08 02:21:57  cvs
//  The Meta Functions have been implemented and these are the files
//  that had to be modified.Addded some accessor methods to classes
//  like SOM_DeclarationStatement, SOM_Expression,
//  SOM_RecordTupleDeclarationStatement.The Meta functions for facet
//  terms and the term items are implemented   
//  --srinivas
//
//  Revision 1.8  2000/03/23 00:22:45  cvs
//  Huge commit! Added all the essential accessor methods for the
//  following classes 
//  - Krishna and Makarand
//
//  Revision 1.7  2000/03/03 18:38:27  cvs
//  Seriliazing and deserializing the object model - makarand
//
//  Revision 1.6  2000/02/17 01:20:13  cvs
//  Completed the implementation for component declarations (with the help of
//  makarand); this involved grammar changes, populating the object model and
//  also the pretty-printing.
//  - krishna
//
//  Revision 1.5  2000/02/10 00:37:11  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.4  2000/02/08 18:42:21  cvs
//  Completed populating the object model and publishing the object model.
//  Added 'publishSOM(PrintWriter)' method to all necessary classes
//  (with the help 
//  of Makarand and Srini). Removed some unnecessary classes (due to changes
//  brought to the grammar). Renamed SOM_EqualityOperator to
//  SOM_EqualEqualOperator. Modified SldlParser.jj.h to populate the
//  object model. 
//  -- Cindy.
//
//  Revision 1.3  1999/11/16 04:05:23  cvs
//  Added support for export clause and visiblity
//
//  Revision 1.2  1999/11/13 20:01:25  cvs
//  Changed to the new OM and grammar. Some more features are to be added
//  and many bugs to be corrected. This is a commit for record and it compiles
//
//  Revision 1.1  1999/11/11 00:04:19  cvs
//  Fresh changes as part of the streamlining process with new
//  object model and grammar
//
//
//=============================================================================
package SOM;

import util.Link;
import util.ListEnumeration;
import ROM.*;
import java.io.PrintWriter;
import java.io.*;
import util.List;

/** This represents the <B>ComponentDeclaration</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_ComponentDeclaration
extends SOM_Declaration 
implements SOM_PackageDeclarativeItem{

	private SOM_Identifier id;
	private SOM_InterfaceListing interfaceList = null;
	private SOM_ComponentDeclarativeBlock declBlock = null;
	private SOM_ExportBlock exportBlock = null;

	// The individual internal facets
	/* private SOM_FacetDeclaration assumptionFacet;
	   private SOM_FacetDeclaration definitionFacet;
	   private SOM_FacetDeclaration verificationFacet; */
	/* commented by makarand as individual facets are split in new grammar */
	private SOM_AssumptionBlock assumptionBlock;
	private SOM_DefinitionBlock defBlock;
	private SOM_VerificationBlock verBlock;

	private transient SOM_DeclarationList domainList;

	/** The primary constructor
	 * @param compTypeIn The typeDeclaration corresponding to the
	 * "component type"
	 * @return Not applicable
	 */
	public SOM_ComponentDeclaration(SOM_TypeDeclaration compTypeIn) {
	    super();
	    setKind(COMPONENT);
	    setType(compTypeIn);
	}

	/** To set the identifier
	 * @param idIn The SOM_Identifier to be set
	 * @return void
	 */
	public void setIdentifier(SOM_Identifier idIn) {
	    id = idIn;
	}			 
	 
	/** To get the identifier
	 * @return The SOM_Identifier for this designUnit
	 */
	public SOM_Identifier getIdentifier() {
	    return id;
	}

	/** To set the interfaceListing - implements the function from
	 * SOM_DesignUnit
	 * @param interfaceIn The SOM_InterfaceListing object to be set
	 * @return void
	 */
	public void setInterfaceListing(SOM_InterfaceListing interfaceIn) {
	    interfaceList = interfaceIn;
	}

	/** To get the interfaceListing - implements the function from
	 * SOM_DesignUnit
	 * @return The SOM_InterfaceListing object for this designUnit
	 */
	public SOM_InterfaceListing getInterfaceListing() {
	    return interfaceList;
	}

	/** To set the domainList - implements the function from
	 * SOM_DesignUnit
	 * @param domainListIn The SOM_DeclarationList object to be set
	 * @return void
	 */
	public void setDomainList(SOM_DeclarationList domainListIn) {
		domainList = domainListIn;
	}

	/** To get the domainList - implements the function from
	 * SOM_DesignUnit
	 * @return The SOM_DeclarationList object for this designUnit
	 */
	public SOM_DeclarationList getDomainList() {
		return domainList;
	}

	/** To set the componentDeclarativeBlock
	 * @param declIn The SOM_ComponentDeclarativeBlock to be set
	 * @return void
	 */
	public void setComponentDeclarativeBlock
		(SOM_ComponentDeclarativeBlock declIn) {
	    declBlock = declIn;
	}

	/** To get the componentDeclarativeBlock
	 * @return The SOM_ComponentDeclarativeBlock for this component
	 */
	public SOM_ComponentDeclarativeBlock getComponentDeclarativeBlock() {
	    return declBlock;
	}

	/** To set the export block
	 * @param blockIn The SOM_ExportBlock to be set
	 * @return void
	 */
	public void setExportBlock(SOM_ExportBlock blockIn) {
	    exportBlock = blockIn;
	}

	/** To get the exports as a ListEnumeration 
	 * @return ListEnumeration corresponding to the export clauses
	 */
	public ListEnumeration exports() {
		if (exportBlock != null) 
			return exportBlock.exports();
		else
			return null; 
	}
    
	/* To set the assumption facet
	 * @param facetIn The SOM_FacetDeclaration to be set as the
	 *  assumption facet
	 * @return void
	 *
	 public void setAssumptionFacet(SOM_FacetDeclaration facetIn) {
	 assumptionFacet = facetIn;
	 }
	 
	 commented by makarand for new component grammar */

	/** To set the assumption facet
	 * @param assumpBlockIn The SOM_AssumptionBlock to be set as the
	 *  assumption facet
	 * @return void
	 */
    public void setAssumptionBlock(SOM_AssumptionBlock assumpBlockIn){
		assumptionBlock = assumpBlockIn;
    }

	 /** To get the assumption facet
	 * @return The SOM_AssumptionBlock of the	assumption facet
	 */
    public SOM_AssumptionBlock getAssumptionBlock(){
		return assumptionBlock;
    }

    /* To set the definition facet
     * @param facetIn The SOM_FacetDeclaration to be set as the
     * definition facet
     * @return void
     *
     * public void setDefinitionFacet(SOM_FacetDeclaration facetIn) {
     definitionFacet = facetIn;
     } 
     commented by makarand for new component grammar */
    
    /** To set the definition facet
     * @param defBlockIn The SOM_DefinitionBlock to be set as the
     *  definition facet
     * @return void
     */
    public void setDefinitionBlock(SOM_DefinitionBlock defBlockIn){
		defBlock = defBlockIn;
    }

	/** To get the definition facet
	 * @return The SOM_DefinitionBlock of the	definition facet
	 */
    public SOM_DefinitionBlock getDefinitionBlock(){
		return defBlock;
    }

    /* To set the verification facet
     * @param facetIn The SOM_FacetDeclaration to be set as the
     * verification facet
     * @return void
     *
     *public void setVerificationFacet(SOM_FacetDeclaration facetIn) {
	 verificationFacet = facetIn;
	 }
	 * commented by makarand for new component grammar */
     
    /** To set the verification facet
     * @param verBlockIn The SOM_VerificationBlock to be set as the
     *  verification facet
     * @return void
     */
    public void setVerificationBlock(SOM_VerificationBlock verBlockIn){
		verBlock = verBlockIn;
    }

	/** To get the verification facet
	 * @return The SOM_VerificationBlock of the	verification facet
	 */
    public SOM_VerificationBlock getVerificationBlock(){
		return verBlock;
    }
	
    /** To get the string representation of this object. Overriding the
     * method in SOM_Declaration 
     * @return String The "name" of the facet corresponding to this
     * declaration 
     */
    public String toString() {
		return id.toString();
    }

	/** added by krishna on Mar 5, 2000
	 * To get the desired object by traversal of SOM
	 * to be implemented later
	 */
	public ListEnumeration M__Terms() {
		//System.out.println("Compo decl entered");
		//return getFacetDefinition().getFacetBody().items();
		return new ListEnumeration(null);
	}

	/** added by srinivas on Nov 2nd, 2000
	 * To get the parameters passed to the component.It returns a
	 * ListEnumeration of the SOM_InterfaceItems.
	 * @param void
	 * return ListEnumeration
	 */
	public ListEnumeration M__Params() {
		List params = new List();
		if (getInterfaceListing() !=null){
			ListEnumeration  interListEnum =
				getInterfaceListing().interfaces();
			SOM_InterfaceItem interItem;
			if (interListEnum != null){
				while (interListEnum.hasMoreElements()){
					interItem = (SOM_InterfaceItem)
						interListEnum.nextElement();
					if(interItem !=null)
						params.addElement((Object)interItem);
				}
			}
		}
		if (params.isEmpty()){
			return null;
		}
		else{
			return params.elements();
		}
    }
	
	/** added by srinivas on Nov 2nd, 2000
	 * To get the list of physical variables declared
	 * @param void
	 * @return ListEnumeration
	 */
	public ListEnumeration M__Pvars() {
		ListEnumeration compDeclItemEnum;
		List pVars = new List();
		ListEnumeration idListEnum;
		if (getComponentDeclarativeBlock() != null){
			compDeclItemEnum =
				getComponentDeclarativeBlock().items();
			if (compDeclItemEnum !=null){
				while (compDeclItemEnum.hasMoreElements()){
					SOM_ComponentDeclarativeItem compDeclItem =
						((SOM_ComponentDeclarativeItem)compDeclItemEnum.
						 nextElement());
					if (compDeclItem instanceof SOM_DeclarationStatement){
						pVars.addElement(((Object)
										  ((SOM_DeclarationStatement)
										   compDeclItem)
										  .getIdentifier()));
						if (((SOM_DeclarationStatement)compDeclItem)
							.getIdentifierListing() !=null){
							idListEnum = ((SOM_DeclarationStatement)
										  compDeclItem).
								getIdentifierListing().identifiers();
							while(idListEnum.hasMoreElements()){
								pVars.addElement((Object)idListEnum.
												 nextElement());
							}
						}
					}
				}
			}
		}
		if (pVars.isEmpty()){
			return null;
		} else
			return pVars.elements();
    }


	/** added by srinivas on Mar 29, 2000
	 * To get the desired object by traversal of SOM
	 * to be implemented later
	 */
	public ListEnumeration M__Visible() {
		//System.out.println("Compo decl entered");
		//return getFacetDefinition().getFacetBody().items();
		return new ListEnumeration(null);
	}
	/** added by srinivas on Mar 29, 2000
	 * To get the desired object by traversal of SOM
	 * to be implemented later
	 */
	public ListEnumeration M__Types() {
		//System.out.println("Compo decl entered");
		//return getFacetDefinition().getFacetBody().items();
		return new ListEnumeration(null);
	}
	/** added by srinivas on Mar 29, 2000
	 * To get the desired object by traversal of SOM
	 * to be implemented later
	 */
	public ListEnumeration M__Items() {
		//System.out.println("Compo decl entered");
		//return getFacetDefinition().getFacetBody().items();
		return new ListEnumeration(null);
	}
	
	/** added by srinivas on Mar 29, 2000
	 * To get the desired object by traversal of SOM
	 * to be implemented later.It returns NULL since the component
	 * declaration doesnot have a DOMAIN.
	 */
	public String M__Domain() {
		return  null;
	}

	/** Added by srinivas on Nov 5th 2000
     * To get all the declaration statements that are declared
     * in the component
	 * @param void
	 * @return ListEnumeration
     */
    public ListEnumeration getDeclarationStatements(){
		SOM_ComponentDeclarativeBlock declBlock =
			getComponentDeclarativeBlock();
		List declStmts = new List();
		if (declBlock != null){
			ListEnumeration compDeclStmts = declBlock.items();
			if (compDeclStmts != null){
				while(compDeclStmts.hasMoreElements()){
					SOM_ComponentDeclarativeItem declItem =
						(SOM_ComponentDeclarativeItem)compDeclStmts.
						nextElement();
					if (declItem instanceof SOM_DeclarationStatement){
						SOM_DeclarationStatement declStmt =
							((SOM_DeclarationStatement)declItem);
						declStmts.addElement(declStmt);
					}
				}
			}
		}
		if (declStmts.isEmpty())
			return null;
		else
			return declStmts.elements();
    }
	
	//Added by srinivas on Nov 2nd, 2000
	/*To get the label of the component declared
	 * @param void
	 * @return String
	 */
	public String M__Label(){
		return id.toString();
	}

	//Added by srinivas on Nov 2nd, 2000
	/* To get the string of the component declaration
	 * @param void
	 * @return String
	 */
	public String M__String(){
		try{
			String str = new String();
			StringWriter sw = new StringWriter();
			PrintWriter pw = new PrintWriter(sw,true);
			publishSOM(pw);
			pw.flush();
			pw.close();
			str = sw.toString();
			sw.close(); 
			return str;
		}
		catch (Exception e) {
			System.out.println(e);
			return (String)null;
		}
    }
		
	//Added by srinivas on Nov 2nd, 2000
	/* To get the type of the component declaration
	 * @param void
	 * @return String
	 */
	public String M__Type(){
		String str = "component";
		return str;
	}

	//Added by srinivas on Oct 27th, 2000. This function returns the
	//ROM.Expression 
	/** The function that creates the ROM.Expression for the facet 
	 * item
	 * @param Factory,BaseObject,Universe
	 * @return ROM.Expression(ROM.Facet)
	 */
	public Expression M__Value(Factory romFactory,
							   BaseObject parent, Universe root){
		
		ROM.Component compValue = (ROM.Component)parent;
		
		// ***** Populating the component value ***** //
		
		// Populating the interface items
		ListEnumeration paramList = M__Params();
		SOM_InterfaceItem interItem;
		if (paramList != null) {
			while (paramList.hasMoreElements()) {
				interItem = (SOM_InterfaceItem)paramList.nextElement();
				compValue.addInterfaceItem
					(interItem.buildROM(romFactory, root, compValue));
			}
		}

		// Populating the declared items
		ListEnumeration declList = getDeclarationStatements();
		SOM_ComponentDeclarativeItem compDeclItem;
		if (declList != null) {
		  while (declList.hasMoreElements()) {
			compDeclItem =
			  (SOM_ComponentDeclarativeItem)declList.nextElement();
			if (compDeclItem instanceof SOM_DeclarationStatement){
			  SOM_DeclarationStatement decl =
				(SOM_DeclarationStatement)compDeclItem;
			  compValue.addItem(decl.buildROM(romFactory, root, compValue));
			}
		  }
		}

		// Populating the export list
		ListEnumeration exportList = exports();
		SOM_Identifier exportId;
		if (exportList != null) {
			if (!exportList.hasMoreElements()) {
				compValue.addExportLabel
					(romFactory.newLabel((Item)compValue.getParent(),
										 "ALL"));
			} else {										  
				while (exportList.hasMoreElements()) {
					exportId = (SOM_Identifier)exportList.nextElement();
					compValue.addExportLabel
						(romFactory.newLabel((Item)compValue.getParent(), 
											 exportId.toString()));
				}
			}
		}

		//creating the assumption item
		LabelledItem assumption = romFactory.newLabelledItem
			(compValue, null, null, null, getAssumptionString());
		//creating the definition item
		LabelledItem definition = romFactory.newLabelledItem
			(compValue, null, null, null, getDefinitionString());
		//creating the verification, assumption and definition items
		LabelledItem verification =	romFactory.newLabelledItem
			(compValue, null, null, null, getVerificationString());
		Label assumptionLabel = romFactory.newLabel(assumption, "assumption");
		assumption.setLabel(assumptionLabel);
	    Label definitionLabel = romFactory.newLabel(definition, "definition");
		definition.setLabel(definitionLabel);
		Label verificationLabel = 
			romFactory.newLabel(verification, "verification");
		verification.setLabel(verificationLabel);		

		assumption.setValue(getValue(assumptionBlock, romFactory, 
									 assumption, root));
		compValue.setAssumption(assumption);

		definition.setValue(getValue(defBlock, romFactory, 
									 definition, root));
		compValue.setDefinition(definition);

		verification.setValue(getValue(verBlock, romFactory, 
									   verification, root));
		compValue.setVerification(verification);

		((ComponentType)root.getType("component")).addOneElement(compValue);
		
		// To be completed
		// Populating the use clause list
		return (Expression)compValue;
	}
	
	/*This method is used to get the value of assumption,definition,
	 * and verification blocks
	 * @param SOM_Declaration
	 * @param Factory
	 * @param BaseObject
	 * @return Expression
	 */
	public Expression getValue(SOM_Declaration decl, Factory romFactory, 
							   BaseObject parent, Universe root){
		if (decl instanceof SOM_AssumptionBlock){
			SOM_AssumptionBlock assumption = (SOM_AssumptionBlock)decl;
			if (assumption.getFacetDefinition() != null) {
				// Creating the value first
				ROM.Facet assumptionValue = romFactory.newFacet((Item)parent);
				// The object facetValue is being modified directly
				// but not created 
				return assumption.getFacetDefinition().
					M__Value(romFactory, assumptionValue, root);
			} else if (assumption.getFacetExpression() != null)
				return assumption.getFacetExpression().
					M__Value(romFactory, parent, root);
			else
				return null;
			
		}else if (decl instanceof SOM_DefinitionBlock){
			SOM_DefinitionBlock definition = (SOM_DefinitionBlock)decl;
			if (definition.getFacetDefinition() != null) {
				// Creating the value first
				ROM.Facet definitionValue = romFactory.newFacet((Item)parent);
				// The object facetValue is being modified directly
				// but not created 
				return definition.getFacetDefinition().
					M__Value(romFactory, definitionValue, root);
			} else if (definition.getFacetExpression() != null)
				return definition.getFacetExpression().
					M__Value(romFactory, parent, root);
			else
				return null;

		}else if (decl instanceof SOM_VerificationBlock){
			SOM_VerificationBlock verification = (SOM_VerificationBlock)decl;
			if (verification.getFacetDefinition() != null) {
				// Creating the value first
				ROM.Facet verificationValue = 
					romFactory.newFacet((Item)parent);
				// The object facetValue is being modified directly
				// but not created
				return verification.getFacetDefinition().
					M__Value(romFactory, verificationValue, root);
			} else if (verification.getFacetExpression() != null)
				return verification.getFacetExpression().
					M__Value(romFactory, parent, root);
			else 
				return null;

		}else{
			return null;
		}
	}
	
	/*The function returns the string of the assumption block
	 * @param void
	 * @return String
	 */
	public String getAssumptionString(){
		try {
			StringWriter sw = new StringWriter();
			PrintWriter pw = new PrintWriter(sw,true);
			assumptionBlock.publishSOM(pw);
			return sw.toString();
		}catch(Exception e){
			System.out.println(e);
			return null;
		}
	}
	/*The function returns the string of the definition block
	 * @param void
	 * @return String
	 */
	public String getDefinitionString(){
		try {
			StringWriter sw = new StringWriter();
			PrintWriter pw = new PrintWriter(sw,true);
			defBlock.publishSOM(pw);
			return sw.toString();
		}catch(Exception e){
			System.out.println(e);
			return null;
		}
	}
	
	/*The function returns the string of the verification block
	 * @param void
	 * @return String
	 */
	public String getVerificationString(){
		try {
			StringWriter sw = new StringWriter();
			PrintWriter pw = new PrintWriter(sw,true);
			verBlock.publishSOM(pw);
			return sw.toString();
		}catch(Exception e){
			System.out.println(e);
			return null;
		}
	}

	//Added by srinivas on Nov 5th, 2000
	/** The buildROM method for this high-level item
	 * @param ROMFactory, Factory object used to create objects in ROM
	 * @return LabelledItem, corresponding to this facet  
	 */
	
	public LabelledItem buildROM(Factory romFactory, Universe
								 root, BaseObject parentIn) {
		LabelledItem componentItem = romFactory.newLabelledItem
			(parentIn, null, null, null, M__String());
		Label compLabel = romFactory.newLabel(componentItem, toString());
		componentItem.setLabel(compLabel);

		ROM.Component compValue = romFactory.newComponent
			(componentItem);
		componentItem.setValue(compValue);
		// The object compValue is being modified directly but not created
		M__Value(romFactory, compValue, root);

		Type compType = root.getType("component");
		componentItem.setType(compType);
		return componentItem;
	}

    // added  by makarand
    /** publishSOM routine to print object model
     * @param PrintWriter pw
     * @return void
     */
    public void publishSOM(PrintWriter pw) {
		pw.print("COMPONENT ");
		id.publishSOM(pw);
		if(interfaceList != null){
			interfaceList.publishSOM(pw);
		}
		pw.println(" IS");
		if(declBlock != null){
			declBlock.publishSOM(pw);
		}
		if(exportBlock != null){
			exportBlock.publishSOM(pw);
		}
		assumptionBlock.publishSOM(pw);
		defBlock.publishSOM(pw);
		verBlock.publishSOM(pw);
		pw.print("END ");
		id.publishSOM(pw);
		pw.println(";");
		pw.println();
    }
    
}


