//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_ComponentDeclarativeItemList.java,v 1.2 2000/02/10 00:37:12 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_ComponentDeclarativeItemList.java,v $
//  Revision 1.2  2000/02/10 00:37:12  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/11/11 00:04:20  cvs
//  Fresh changes as part of the streamlining process with new
//  object model and grammar
//
//
//=============================================================================
package SOM;

/** This represents the <B>ComponentDeclarativeItemList</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_ComponentDeclarativeItemList
extends SOM_List{

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_ComponentDeclarativeItemList() {
		super();
	}

	/** The Second Constructor
	 * @param itemIn The first SOM_ComponentDeclarativeItem object to be added
	 * @return Not applicable
	 */
	public SOM_ComponentDeclarativeItemList(SOM_ComponentDeclarativeItem itemIn) {
		super((SOM_BaseClass)itemIn);
	}

	/** To add a SOM_ComponentDeclarativeItem to the list
	 * @param itemIn The SOM_ComponentDeclarativeItem object to be added
	 * @return void
	 */
	public void addElement(SOM_ComponentDeclarativeItem itemIn) {
		super.addElement((SOM_BaseClass)itemIn);
	}
}
