//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_DesignUnitList.java,v 1.3 2000/03/03 18:38:28 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_DesignUnitList.java,v $
//  Revision 1.3  2000/03/03 18:38:28  cvs
//  Seriliazing and deserializing the object model - makarand
//
//  Revision 1.2  2000/02/10 00:37:13  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/10/27 20:43:31  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:49:33  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.5  1999/07/13 14:27:08  rkamath
//  Changed the publishRosetta() function to take in a PrintWriter
//  Added some new classes too.
//  Also commented out currency based operations from the SOM_List class. Hope-
//  fully at a later date I'll include them in the SOM_ListEnumeration class if
//  found necessary.
//
//  Revision 1.4  1999/07/09 22:21:09  rkamath
//  A lot of changes to incorporate the intent of type checking
//
//  Revision 1.3  1999/06/25 15:10:21  rkamath
//  Modified the Makefile and changed the javadoc comments in the java files
//
//  Revision 1.2  1999/06/23 18:34:58  rkamath
//  A fresh new addition and modification of new files
//
//  Revision 1.1  1999/06/18 21:15:02  rkamath
//  The first commit for the SOM (SLDL Object Model). The DesignUnit is purely to
//  enable compilation and is yet incomplete...
//
//
//=============================================================================
package SOM;
import java.io.*;

/** This represents the <B>DesignUnitList</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 * @see SOM.SOM_List
 * @see SOM.SOM_DesignUnit
 */
public class SOM_DesignUnitList
extends SOM_List 
implements Serializable {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_DesignUnitList() {
		super();
	}

	/** The Second Constructor
	 * @param dUnit The SOM_DesignUnit to be stored first
	 * @return Not applicable
	 */
	public SOM_DesignUnitList(SOM_DesignUnit dUnit) {
		super((SOM_BaseClass)dUnit);
	}

	/** To append a SOM_DesignUnit
	 * @param dUnit The SOM_DesignUnit to be appended
	 * @return void
	 */
	public void addElement(SOM_DesignUnit dUnit) {
		super.addElement((SOM_BaseClass)dUnit);
	}
   
}
