//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_EnumerationListing.java,v 1.2 2000/02/10 00:37:14 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_EnumerationListing.java,v $
//  Revision 1.2  2000/02/10 00:37:14  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/10/27 20:43:32  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:49:44  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.4  1999/07/28 01:59:37  rkamath
//  Changed all the SOM_Declaration references to SYM_SymboltableEntry as far
//  as lookUp and typeResolution are concerned
//
//  Revision 1.3  1999/07/16 21:50:27  rkamath
//  Changed everyexpression to point to the type declaration instead of having
//  a private variable which would indicate the resulting type
//
//  Revision 1.2  1999/07/13 14:27:12  rkamath
//  Changed the publishRosetta() function to take in a PrintWriter
//  Added some new classes too.
//  Also commented out currency based operations from the SOM_List class. Hope-
//  fully at a later date I'll include them in the SOM_ListEnumeration class if
//  found necessary.
//
//  Revision 1.1  1999/07/06 21:01:35  rkamath
//  Having added the type expression syntax the corresponding OM...etc
//  Also now, only subclasses of RuntimeException are being thrown
//
//
//=============================================================================
package SOM;

/** This represents the <B>EnumerationListing</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_EnumerationListing
extends SOM_BaseClass
implements SOM_TypeExpression {

	private SOM_EnumerationItemList enumList = new SOM_EnumerationItemList();

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_EnumerationListing() {
		super();
	}

	/** Overriding the function in the interface SOM_TypeExpression
	 * @return Not applicable
	 * @exception SOM.SOM_MethodNotSupportedException always
	 */
	/*
	public SOM_Declaration getParentType() {
		throw new SOM_MethodNotSupportedException(getClassName() + ": getParentType() not supported for this class");
	}
	*/

	/** To add to the enumerationList
	 * @param item The SOM_EnumerationItem to be added
	 * @return void
	 */
	public void addToEnumerationItemList(SOM_EnumerationItem item) {
		enumList.addElement(item);
	}
}
