//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_FacetBodyItemList.java,v 1.3 2000/02/10 00:37:17 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_FacetBodyItemList.java,v $
//  Revision 1.3  2000/02/10 00:37:17  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.2  1999/11/11 00:04:20  cvs
//  Fresh changes as part of the streamlining process with new
//  object model and grammar
//
//  Revision 1.1  1999/11/05 23:43:06  cvs
//  Modified this file as part of streamlining the ObjectModel and bringing
//  it in line with the new grammar
//
//
//=============================================================================
package SOM;

/** This represents the <B>FacetBodyItemList</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_FacetBodyItemList
extends SOM_List{

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_FacetBodyItemList() {
		super();
	}

	/** The Second Constructor
	 * @param itemIn The first SOM_FacetBodyItem object to be added
	 * @return Not applicable
	 */
	public SOM_FacetBodyItemList(SOM_FacetBodyItem itemIn) {
		super((SOM_BaseClass)itemIn);
	}

	/** To add a SOM_FacetBodyItem to the list
	 * @param itemIn The SOM_FacetBodyItem object to be added
	 * @return void
	 */
	public void addElement(SOM_FacetBodyItem itemIn) {
		super.addElement((SOM_BaseClass)itemIn);
	}
}
