//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_FacetDeclarativeBlock.java,v 1.3 2000/02/10 00:37:17 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_FacetDeclarativeBlock.java,v $
//  Revision 1.3  2000/02/10 00:37:17  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.2  2000/02/08 18:42:27  cvs
//  Completed populating the object model and publishing the object model.
//  Added 'publishSOM(PrintWriter)' method to all necessary classes (with the help
//  of Makarand and Srini). Removed some unnecessary classes (due to changes
//  brought to the grammar). Renamed SOM_EqualityOperator to
//  SOM_EqualEqualOperator. Modified SldlParser.jj.h to populate the object model.
//  -- Cindy.
//
//  Revision 1.1  1999/11/11 00:04:21  cvs
//  Fresh changes as part of the streamlining process with new
//  object model and grammar
//
//
//=============================================================================
package SOM;

import util.ListEnumeration;

import java.io.PrintWriter;

/** This represents the <B>FacetDeclarativeBlock</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_FacetDeclarativeBlock
extends SOM_BaseClass {

	private SOM_FacetDeclarativeItemList itemList = new SOM_FacetDeclarativeItemList();

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_FacetDeclarativeBlock() {
		super();
	}

	/** To add a FacetDeclarativeItem to the itemList
	 * @param itemIn The SOM_FacetDeclarativeItem to be added to the itemList
	 * @return void
	 */
	public void addToFacetDeclarativeItemList(SOM_FacetDeclarativeItem itemIn) {
		itemList.addElement(itemIn);
	}

	/** To retrieve the listEnumeration of the itemList
	 * @return The ListEnumeration corresponding to the itemList
	 */
	public ListEnumeration items() {
		return itemList.elements();
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		ListEnumeration itemEnum = this.items();
		SOM_FacetDeclarativeItem item;

		while (itemEnum.hasMoreElements()) {
			item = (SOM_FacetDeclarativeItem)itemEnum.nextElement();
			item.publishSOM(pw);
		}
	}
}

