//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Krishna  krishna@ittc.ukans.edu
//
//  $Id: SOM_FacetExpressionTail.java,v 1.2 2001/03/12 23:54:38 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_FacetExpressionTail.java,v $
//  Revision 1.2  2001/03/12 23:54:38  cvs
//  Changed the order of precedence of the "=" operator. It now has lowest
//  precedence of all operators except for the "==" operator. Added some
//  type checking for facet expressions and as a result, domain names have
//  to be legal facet names. Removed several bugs as well.
//  -- Cindy
//
//  Revision 1.1  2000/02/17 01:27:05  cvs
//  Implemented the facet expression grammar to incorporate facet composition.
//  Also updated the "use" clause with the above changes.
//  - krishna.
//
//
//
//=============================================================================
package SOM;

import java.io.PrintWriter;

/** This represents the <B>FacetExpressionTail</B> object
 * @author <I>Krishna Ranganathan</I> (krishna@ittc.ukans.edu)
 */
public class SOM_FacetExpressionTail
extends SOM_AbstractExpressionTail {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_FacetExpressionTail() {
		super();
	}

	/** To set the implies operator
	 * @param opIn The SOM_ImpliesOperator to be set
	 * @return void
	 */
	public void setImpliesOperator(SOM_DyadicOperator opIn) {
		setOperator(opIn);
	}

	/** To set the facetAndExpression
	 * @param facetAndExprIn The SOM_FacetAndExpression to be set
	 * @return void
	 */
	public void setFacetAndExpression(SOM_FacetAndExpression facetAndExprIn) {
		setExpression(facetAndExprIn);
	}

	/** To get the facetAndExpression
	 * @return SOM_FacetAndExpression
	 */
	public SOM_FacetAndExpression getFacetAndExpression() {
		return (SOM_FacetAndExpression)getExpression();
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		getOperator().publishSOM(pw);
		getExpression().publishSOM(pw);
	}
}

