//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_Factor.java,v 1.11 2000/11/18 00:18:27 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_Factor.java,v $
//  Revision 1.11  2000/11/18 00:18:27  cvs
//  Changed the M__Value method so that it takes ROM.Factory as a parameter
//  --srinivas
//
//  Revision 1.10  2000/10/30 22:13:23  cvs
//  The M__Value  function is implemented for the terms(SOM_LabelledExpression) and it returns a ROM Expression.
//  --srinivas
//
//  Revision 1.9  2000/08/01 22:48:48  cvs
//  added publishPVS templates in each of the expression subclasses.
//  Currently SOCCER supports PVS translation of "%" and "-" unary operator,
//  other translations can be done in these publishPVS templates as and when
//  needed - makarand.
//
//  Revision 1.8  2000/06/22 17:22:42  cvs
//  I modified the grammar to remove an error during parsing for record and tuple.
//  -- Cindy
//
//  Revision 1.7  2000/04/06 19:13:20  cvs
//  Type checking is done for declaration of variables (simple types), for declaration of new types and for use of basic operators.
//   -- Cindy
//
//  Revision 1.6  2000/03/23 00:22:47  cvs
//  Huge commit! Added all the essential accessor methods for the following classes
//  - Krishna and Makarand
//
//  Revision 1.5  2000/03/03 18:38:29  cvs
//  Seriliazing and deserializing the object model - makarand
//
//  Revision 1.4  2000/02/10 00:37:18  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.3  2000/02/08 18:42:27  cvs
//  Completed populating the object model and publishing the object model.
//  Added 'publishSOM(PrintWriter)' method to all necessary classes (with the help
//  of Makarand and Srini). Removed some unnecessary classes (due to changes
//  brought to the grammar). Renamed SOM_EqualityOperator to
//  SOM_EqualEqualOperator. Modified SldlParser.jj.h to populate the object model.
//  -- Cindy.
//
//  Revision 1.2  1999/11/05 23:43:09  cvs
//  Modified this file as part of streamlining the ObjectModel and bringing
//  it in line with the new grammar
//
//  Revision 1.1  1999/10/27 20:43:35  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:50:03  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.4  1999/07/14 23:23:44  rkamath
//  Added a generic semCheck function in SOM_AbstractExpression
//  All the other "expressionTail"s now inherit from SOM_AbstractExpressionTail
//  So also for the "expressionTailList"s
//  SOM_Operator now inherits from SOM_Function
//
//  Revision 1.3  1999/06/30 22:19:57  rkamath
//  Compeleted the object model coding for the expression grammar
//  The expression objects now inherit from a AbstractExpression class
//
//  Revision 1.2  1999/06/30 02:19:02  rkamath
//  Added a lot more files dealing with the expression OM.
//  Also modified some previous classes
//  Now the ROOT in the hierarchy is the SOM_Unifier interface.
//
//  Revision 1.1  1999/06/27 17:33:29  rkamath
//  Added some of the object model for the Expression grammar and a few changes to
//  the other files..
//
//
//=============================================================================
package SOM;

import java.io.PrintWriter;

import java.io.*;
import ROM.*;
/** This represents the <B>Factor</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
// made serializable by makarand

public interface SOM_Factor extends Serializable{

	//added by srinivas on Oct 24th 2000
    /*The Meta Function to get the value of the item
     *@param BaseObject parent
	 *@param Universe root
     * @return Expression
     */	
	public abstract Expression M__Value(Factory romFactory,
										BaseObject parent,Universe root);
	/** The publishSOM routine for this class
	 * @return void
	 */
    public abstract void publishSOM(PrintWriter pw);

	/** accessor routines for Labelled expression
	 * added by Krishna and Makarand on Mar 7, 2000
     */
	public SOM_Label getLabel();
	public SOM_Expression getLabelExpression();

		/** The publishPVS routine for this class
		 * @return void
		 * added by makarand for SOCCER, 7/19/2000
		 */
    public abstract void publishPVS(PrintWriter pw);
}



