//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Krishna  krishna@ittc.ukans.edu
//
//  $Id: SOM_SelectedNameList.java,v 1.1 2000/02/17 01:27:06 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_SelectedNameList.java,v $
//  Revision 1.1  2000/02/17 01:27:06  cvs
//  Implemented the facet expression grammar to incorporate facet composition.
//  Also updated the "use" clause with the above changes.
//  - krishna.
//
//
//
//=============================================================================
package SOM;

/** This represents the <B>SelectedNameList</B> object
 * @author <I>Krishna Ranganathan</I> (krishna@ittc.ukans.edu)
 * @see SOM.SOM_List
 * @see SOM.SOM_SelectedName
 */
public class SOM_SelectedNameList
extends SOM_List{

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_SelectedNameList() {
		super();
	}

	/** The Second Constructor
	 * @param selectedName The first SOM_SelectedName object to be added
	 * @return Not applicable
	 */
	public SOM_SelectedNameList(SOM_SelectedName selectedName) {
		super(selectedName);
	}

	/** To add a SOM_SelectedName to the list
	 * @param selectedName The SOM_SelectedName object to be added
	 * @return void
	 */
	public void addElement(SOM_SelectedName selectedName) {
		super.addElement(selectedName);
	}
}
