//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_SubTypeExpression.java,v 1.3 2000/03/23 00:22:50 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_SubTypeExpression.java,v $
//  Revision 1.3  2000/03/23 00:22:50  cvs
//  Huge commit! Added all the essential accessor methods for the following classes
//  - Krishna and Makarand
//
//  Revision 1.2  2000/02/10 00:37:33  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/10/27 20:43:49  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:51:36  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.6  1999/10/01 15:23:34  rkamath
//  Commit for record - more cleaner typing ideas.
//
//  Revision 1.5  1999/08/01 20:54:36  rkamath
//  Made a lot of changes with regard to types and checking. I'm convinced that
//  there are going to me hundreds more changes until I stabilize on how to
//  import and [de]serialize
//
//  Revision 1.4  1999/07/28 01:59:45  rkamath
//  Changed all the SOM_Declaration references to SYM_SymboltableEntry as far
//  as lookUp and typeResolution are concerned
//
//  Revision 1.3  1999/07/16 21:50:34  rkamath
//  Changed everyexpression to point to the type declaration instead of having
//  a private variable which would indicate the resulting type
//
//  Revision 1.2  1999/07/13 14:27:45  rkamath
//  Changed the publishRosetta() function to take in a PrintWriter
//  Added some new classes too.
//  Also commented out currency based operations from the SOM_List class. Hope-
//  fully at a later date I'll include them in the SOM_ListEnumeration class if
//  found necessary.
//
//  Revision 1.1  1999/07/06 21:01:47  rkamath
//  Having added the type expression syntax the corresponding OM...etc
//  Also now, only subclasses of RuntimeException are being thrown
//
//
//=============================================================================
package SOM;

/** This represents the <B>SubTypeExpression</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_SubTypeExpression 
extends SOM_BaseClass 
implements SOM_TypeExpression {
		// Only one of the two below should be null
		/* private SOM_LambdaExpression lambdaExpr = null;*/
		private SOM_Identifier restrictionName = null; 

	private SOM_Identifier typeName;
	private SOM_TypeDeclaration type;

	/** The primary constructor
	 * @return Not applicable
	 */
	public SOM_SubTypeExpression() {
		super();
	}

	/** To set the lambdaExpr
	 * @param lamdabExprIn The SOM_LambdaExpression to be set
	 * @return void
	 *
	 public void setLambdaExpression(SOM_LambdaExpression lambdaExprIn) {
	 lambdaExpr = lambdaExprIn;
		}*/

	/** To set the restrictionName
	 * @param nameIn The SOM_Identifier to be set as the restrictionName
	 * @return void
	 */
	public void setRestrictionName(SOM_Identifier nameIn) {
		restrictionName = nameIn;
	}

	/** To set the typeName
	 * @param nameIn The SOM_Identifier to be set as the typeName
	 * @return void
	 */
	public void setTypeName(SOM_Identifier nameIn) {
		typeName = nameIn;
	}

	/** To get the typeName
	 * @return The SOM_Identifier corresponding to the typeName
	 */
	public SOM_Identifier getTypeName() {
		return typeName;
	}

	/** To set the type
	 * @param typeIn The SOM_TypeDeclaration corresponding to the typeName
	 * @return void
	 */
	public void setType(SOM_TypeDeclaration typeIn) {
		type = typeIn;
		typeName = typeIn.getName();
	}

	/** To retreive the type
	 * @return The SOM_TypeDeclaration corresponding to the typeName
	 */
	public SOM_TypeDeclaration getType() {
		return type;
	}
}

